
/*
 * Preference Systemからデータを取得します。
 * @param key
 * @return
 */
function getPref(key) {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var data = null;
	
	if(prefs.getPrefType(key) == prefs.PREF_STRING) {
		data = prefs.getCharPref(key);
	} else if(prefs.getPrefType(key) == prefs.PREF_BOOL) {
		data = prefs.getBoolPref(key);
	} else if(prefs.getPrefType(key) == prefs.PREF_INT) {
		data = prefs.getIntPref(key);
	}
	
	return data;
}

/*
 * Preference Systemにデータを設定します。
 * @paraam key
 * @param data
 */
function setPref(key, data) {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	
	if(prefs.getPrefType(key) == prefs.PREF_STRING) {
		data = prefs.setCharPref(key, data);
	} else if(prefs.getPrefType(key) == prefs.PREF_BOOL) {
		data = prefs.setBoolPref(key, data);
	} else if(prefs.getPrefType(key) == prefs.PREF_INT) {
		data = prefs.setIntPref(key, data);
	}
}