
function Thumbnail(url, size) {
	
	this.url = url;
	this.lock = false;
	this.complete = false;
	
	this.box = null;
	this.image = null;
	this.size = size;
	this.orgImageHeight = 0;
	this.orgImageWidth = 0;
	
	//------------------------
	var pane = document.getElementById("body");
	
	this.box = document.createElement("div");
	pane.appendChild(this.box);
	this.box.setAttribute("style", "overflow:hidden;position:absolute;");
	
	this.image = document.createElement("img");
	this.box.appendChild(this.image);
	this.image.className = "thumbnail";
	
	//------------------------
	
	this.getImageHeight = function() {
		return this.image.height;
	}
	
	this.getImageWidth = function() {
		return this.image.width;
	}
	
	this.getX = function() {
		var x = parseInt(this.box.style.left.replace(/[^0-9]/g, ""));
		return x;
	}
	
	this.getY = function() {
		var y = parseInt(this.box.style.top.replace(/[^0-9]/g, ""));
		return y;
	}
	
	/**
	 * 
	 */
	this.load = function() {
		if(this.lock)
			return;
		
		this.lock = true;
		var image = this.image;
		var thumb = this;
		image.setAttribute("src", this.url);
		
		//読み込み終了時
		image.onload = function() {
			thumb.orgImageWidth = image.width;
			thumb.orgImageHeight = image.height;
			thumb.complete = true;
			
			thumb.repaint();
		}
		
		//クリック時
		image.onclick = function() {
			setPref("moonfox.imgviewer.selected_image", thumb.url);
	
			window.open("chrome://moonfox/content/imgviewer/image.xul"
							, "moonfox_image"
							, "resizable=yes,status=no,toolbar=no");
		}
	}
	
	/**
	 * 
	 */
	this.repaint = function() {
		if(!this.complete)
			return;
		
		var orgWidth = this.orgImageWidth;
		var orgHeight = this.orgImageHeight;
		
		var imgWidth = 0;
		var imgHeight = 0;
		
		if(orgWidth > orgHeight) {
			imgWidth = this.size;
			imgHeight = parseInt(this.size * (orgHeight / orgWidth));
		} else if(orgWidth < orgHeight) {
			imgHeight = this.size;
			imgWidth = parseInt(this.size * (orgWidth / orgHeight));
		} else {
			imgWidth = this.size;
			imgHeight = this.size;
		}
		
		var imgX = parseInt( (this.size - imgWidth) / 2 );
		var imgY = parseInt( (this.size - imgHeight) / 2 );
		
		this.image.width = imgWidth;
		this.image.height = imgHeight;
		this.box.style.width = parseInt(this.size + 5) + "px";
		this.box.style.height = parseInt(this.size + 5) + "px";
		this.image.style.left = imgX + "px";
		this.image.style.top = imgY + "px";
		this.image.style.visibility = "visible";
	}
	
	
	
	/**
	 * 
	 */
	this.setSize = function(size) {
		this.size = size;
		this.box.style.width = parseInt(this.size + 5) + "px";
		this.box.style.height = parseInt(this.size + 5) + "px";
	}
	
	/**
	 * 
	 */
	this.setX = function(x) {
		this.box.style.left = x + "px";
	}
	
	/**
	 * 
	 */
	this.setY = function(y) {
		this.box.style.top = y + "px";
	}
}