

//変数
var startFlg = false;
var exitFlg = true;
var maxThumbNumPerPage = 50;
var currentPage = 1;
var selectedThread = null;

/*
 * ページコンボを構築します。
 */
function constructPageCombo() {
	var cbo = document.getElementById("menulist_page");
	var pagelabel = document.getElementById("label_pagenum");
	var imglabel = document.getElementById("label_imgnum");
	
	var imgnum = getThumbFileList(selectedThread).length;
	var pageNum = parseInt(imgnum / maxThumbNumPerPage) + 1;
	pagelabel.setAttribute("value", "/" + pageNum);
	imglabel.setAttribute("value", imgnum);
	
	for(var i = 1; i <= pageNum; i++) {
		cbo.appendItem(i, i, "");
	}
	
	cbo.value = currentPage;
}

/*
 * スレッドのポップアップメニューを構築します。
 */
function constructThreadPopup() {
	var popup = document.getElementById("popup_thread");
	
	var cacheList = getThreadCacheFileList();
	
	for(var i = 0; i < cacheList.length; i++) {
		var imgFileList = cacheList[i].getAttachFileList(EXT_LIST);
		
		if(!imgFileList ||  imgFileList.length <= 0) {
			continue;
		}
		
		var item = document.createElement("menuitem");
		
		item.setAttribute("label", cacheList[i].getTitle() );
		item.setAttribute("value", cacheList[i].getDirName() );
		
		item.onclick = new Function("threadMenuItemClicked(this);");
		
		popup.appendChild(item);
	}
}

/*
 *
 */
function constructThreadList() {
	var list = document.getElementById("list_thread");
	
	for(var i = 0; i < threadFileList.length; i++) {
		var item = document.createElement("listitem");
		
		item.setAttribute("label", decodeTitle(threadFileList[i].getName()) );
		item.setAttribute("value", threadFileList[i].getName());
		
		list.appendChild(item);
	}
}

/*
 * スクロールバーの現在値からサムネイルサイズを返します。
 *
 * @return
 */
function getThumbSize() {
	var bar = document.getElementById("scrollbar_thumbsize");
	var size = bar.getAttribute("curpos");
	
	return parseInt(size);
}

/*
 * 現在選択されているスレッドのディレクトリを表示します。
 */
function openDirectory() {
	
	if(selectedThread && selectedThread.exist()) {
		selectedThread.getAttachDir().reveal();
	}
}

/**
 * 
 */
function setTitle(title) {
	var text = document.getElementById("text_title");
	text.setAttribute("value", title);
}
