
/**
 * 
 * @param thread nsIThread
 * @param interval 分
 */
function MoonfoxObserver() {
	
	this.thread = null;
	this.interval = 300000;//parseInt(intvl * 60 * 1000);
	this.statusList = {};
	this.working = false;
	this.complete = false;
	
	/**
	 * 
	 */
	this.run = function() {
		this.working = true;
		
		logMsg("スレッドのステータスチェック開始.", false, MoonfoxObserver);
		
		if(threadInfoManager) {
			try {
				var thinfoList = threadInfoManager.getThreadInfoList(null, null, sortType);
				
				var cacheList = getThreadCacheFileList();
				var cacheListDB = {};
				
				for(var i = 0; i < cacheList.length; i++)
					cacheListDB[cacheList[i].getThreadName()] = cacheList[i];
				
				for(var i = 0; i < thinfoList.length; i++) {
					var cache = cacheListDB[thinfoList[i].file];
					
					if(cache) {
						var unread = cache.checkUnreadRecord();
						
						if(unread)
							this.statusList[cache.file.getName()] = UPDATE;
						else
							this.statusList[cache.file.getName()] = READ;
							
						this.thread.sleep(10);
					}
				}
			} catch(e) {
				logMsg(e.toString(), false, MoonfoxObserver);
			}
		}
		
		logMsg("スレッドのステータスチェック終了.", false, MoonfoxObserver);
		
		this.complete = true;
		this.working = false;
	}
	
	/**
	 * 
	 */
	this.getStatus = function(threadName) {
		var status = NOT_READ;
		var cacheFile = null;
		
		try {
			cacheFile = new CacheFile(threadName);
		} catch(e) {
			logMsg(e.toString(), false, MoonfoxObserver);
		}
		
		if(cacheFile && cacheFile.exist() && this.statusList[threadName]) {
			status = this.statusList[threadName];
		}
		
		return status;
	}
	
	/**
	 * 
	 */
	this.isComplete = function() {
		return this.complete;
	}
	
	/**
	 * 
	 */
	this.isWorking = function() {
		return this.working;
	}
	
	/**
	 * ステータスを設定します。
	 */
	this.setStatus = function(threadName, status) {
		this.statusList[threadName] = status;
	}
	
	/**
	 * 
	 */
	this.start = function() {
		this.complete = false;
		var th = Components.classes["@mozilla.org/thread;1"]
				 			.createInstance(Components.interfaces.nsIThread);
		
		this.stop();
		this.thread = th;
		
		this.thread.init(this
						,0
						,Components.interfaces.nsIThread.PRIORITY_NORMAL
						,Components.interfaces.nsIThread.SCOPE_LOCAL
						,Components.interfaces.nsIThread.STATE_UNJOINABLE);
	}
	
	/**
	 * 
	 */
	this.stop = function() {
		if(this.thread && this.working) {
			this.thread.interrupt();
			this.thread = null;
		}
	}
}