var clickedFunc = null;
var clearFunc = null;
var tagManager = null;

/*
 * 
 *
 * @param tags
 */
function appendRow(tags) {
	var row = document.createElement("row");
	
	for(var i = 0; i < tags.length; i++) {
		if(!tags[i] || tags[i] == "")
			break;
		
		var btn = document.createElement("button");
		
		btn.setAttribute("label", tags[i]);
		btn.setAttribute("class", "tag");
		btn.setAttribute("flex", "1");
		btn.setAttribute("tooltiptext", tags[i]);
		
		var func = new Function("clickedFunc('"+tags[i]+"')");
		btn.onclick=func;
		
		row.appendChild(btn);
	}
	
	document.getElementById("rows").appendChild(row);
}

/*
 * タグ表示ボタンを生成します。
 */
function createTagButton() {

	document.getElementById("label_tagnum").setAttribute("value", "(" + tagManager.length() + ")");
	
	for(var i = 0; i < tagManager.length(); i += 4) {
		var tags = new Array();
		
		for(var j = 0; j < 4; j++)
			tags.push(tagManager.getTag(i + j));
		
		appendRow(tags);
	}
}

/*
 * 初期処理
 */
function startup() {
	try {
		var arg = null;
		
		if(window.arguments && window.arguments[0]) {
			arg = window.arguments[0];
			tagManager = arg.tagManager;
			clickedFunc = arg.func;
			
			var clear = document.getElementById("label_clear");
			if(arg.clearFunc) {
				clear.setAttribute("hidden", false);
				clear.onclick = arg.clearFunc;
			}
			
			createTagButton();
		}
	} catch(e) {
		alert(e);
	}
}