
function ImageBox() {
	
	this.elem = document.createElement("img");;
	this.size = getPref("moonfox.thread.image_size");
	
	//----------------
	this.elem.className = "imagebox";
	document.getElementById("body").appendChild(this.elem);		
	//----------------
		
	/**
	 * 
	 */
	this.close = function(event) {
		var left = parseInt(this.elem.style.left.replace(/[^0-9]/g,""));
		var top = parseInt(this.elem.style.top.replace(/[^0-9]/g,""));
		var right = left + this.elem.clientWidth;
		var bottom = top + this.elem.clientHeight;
		
		var mX = event.pageX;
		var mY = event.pageY;
		
		if(mX < left || mX > right || mY < top || mY > bottom)
			this.elem.style.display = "none";
	}
	
	/**
	 * 
	 * @param {Object} event
	 * @param {Object} url
	 */
	this.show = function(event, url) {
		var img = this.elem;
		img.src = url;
		var imgSize = this.size;
		var mX = event.pageX;
		var mY = event.pageY;
		
		img.onload = function() {
			try {
				var ratio = img.width / img.height;
				var width = parseInt(imgSize * ratio);
				var height = imgSize;
				img.style.width = width + "px";
				img.style.height = height + "px";
				
				var x = mX + 25;
				var y = mY - imgSize - 25;
				var pageYOffset = window.pageYOffset;
				
				if(y < pageYOffset)
					y = pageYOffset;
				
				if(x + width > window.innerWidth)
					x -= (x + width) - window.innerWidth;
				
				
				img.style.left = x + "px";
				img.style.top = y + "px";
				
				img.style.display = "block";
			} catch(e) {
				alert(e);
			}
		}
		
		img.onmouseout = function() {
			img.style.display = "none";
		}
		
	}
}