//変数
var cacheFile = null;
var successFunc = null;

/**
 * 添付ファイルを選択。
 */
function chooseAttachFile() {
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"]
        .createInstance(nsIFilePicker);
	fp.init(window, "Select a attach file.", nsIFilePicker.modeOpen);
	
	var res = fp.show();
	if (res == nsIFilePicker.returnOK){
	  var file = new File(fp.file);
	  
	  document.getElementById("text_attach").value = file.getPath();
	}
}

/**
 * 
 */
function doPost() {
	try {
		var ok = confirm(msg("Q_01"));
		if(!ok)
			return;
		
		var articleData = {cmd:"post",dopost:"",file:"",name:"",mail:"",body:"",error:"",attach:"",suffix:"",passwd:""};
		
		articleData.file = cacheFile.file.getName();
		articleData.name = document.getElementById("text_name").value;
		articleData.mail = document.getElementById("text_mail").value;
		articleData.passwd = document.getElementById("text_passwd").value;
		articleData.body = document.getElementById("text_body").value;
		
		articleData.dopost = document.getElementById("check_dopost").checked;
		articleData.error = document.getElementById("check_error").checked;
		
		//添付ファイル
		articleData.attach = document.getElementById("text_attach").value;
		
		self.postform.post(articleData);
		
		//表示の切り替え
		document.getElementById("deck").selectedIndex = 2;
		
		//二重投稿防止
		document.getElementById("button_post").disabled = true;
		//document.getElementById("button_preview").disabled = true;
		
		//投稿後呼び出すメソッド
		setTimeout(successFunc, 2000);
		
		/*
		if(attachFilePath && attachFilePath != "") {
			var attachFile = new File(attachFilePath);
			
			if(!attachFile.exist()) {
				alert("Attach file is not exist.");
				return;
			} else {
				articleData.attach = attachFile;
			}
		}
		*/
		
	} catch(e) {
		alert(e);
	}
}

/**
 * 
 */
function doPreview() {
	try {
		var deck = document.getElementById("deck");
		var sel = parseInt(deck.selectedIndex);
		
		if(sel == 0) {
			deck.selectedIndex = 1;
			var text = document.getElementById("text_body").value;
			self.preview.preview(text);
		} else if(sel == 1) {
			deck.selectedIndex = 0;
		}
	} catch(e) {
		alert(e);
	}
}

/**
 * 
 * @param {Object} request
 */
function postError() {
	alert("Post error");
}

function testrec(request) {
	if (request.readyState == 4) {
		if (request.status == 200) {
			document.getElementById("text_body").value = request.responseText;
		}
	}
}

/**
 * 
 * @param {Object} blockId
 */
function setBlockId(blockId) {
	var body = document.getElementById("text_body");
	var refStr = ">>" + blockId;
	
	if(!body.value || body.value == "") {
		body.value = refStr;
		
	} else if(body.value.indexOf(refStr) < 0) {
		body.value += "\n\n" + refStr;
	}
}

/**
 * 
 */
function startup() {
	try {
		initMsg("chrome://moonfox/locale/messages.properties");
		
		var opt = window.arguments[0];
		cacheFile = opt.cacheFile;
		successFunc = opt.func;
		
		document.title = cacheFile.title + " - 投稿ダイアログ";
		
	} catch(e) {
		alert(e);
	}
}